import matplotlib.pyplot as plt
from mpl_toolkits.mplot3d import Axes3D
import pandas as pd

file_num = 1
fig = plt.figure(figsize=(4, 6))
# For searching the best prediction results
for file_num in range(1, 17):
    print(file_num)

    data_csv = pd.read_csv('../data/ErrorValue/ErrorValue' + str(file_num) + '.csv', header=None)
    x = data_csv[1]
    y = data_csv[3]
    z = data_csv[7]
    # Plotting scatter plots
    fig = plt.figure()
    ax = Axes3D(fig)
    mini = 1000.0
    for i in z:
        if i < mini:
            mini = i
    once = False
    for i in range(len(z)):
        if z[i] == mini and not once:
            once = True
            ax.scatter(x[i], y[i], z[i], marker='x', c='r', s=50)
            ax.text(x[i], y[i], z[i] + 0.001, "(l,m) = (" + str(x[i]) + "," + str(y[i]) + ")", size=12)
        else:
            ax.scatter(x[i], y[i], z[i], c='b', marker='o', s=20)

    # Add axes (Z, Y, X in order)
    ax.set_zlabel('RMSE', fontdict={'size': 12, 'color': 'black'})
    ax.set_ylabel('m', fontdict={'size': 12, 'color': 'black'})
    ax.set_xlabel('l', fontdict={'size': 12, 'color': 'black'})
    plt.title('Ranch Number:' + str(file_num))
    plt.tight_layout()
    plt.savefig('BestSearching-' + str(file_num) + '.pdf', bbox_inches='tight')
