import pandas as pd
import matplotlib.pyplot as plt
import matplotlib.dates as mdates

data_csv_0 = pd.read_csv('result_L_5_m_20.txt')
data_csv_1 = pd.read_csv('../Result-RBF.csv')
data_csv_2 = pd.read_csv('Result-MLPRegressor.csv')
data_csv_3 = pd.read_csv('Result-lstm/Result-LSTM-1-8.csv')
data_csv_4 = pd.read_csv('Result-SVR/Result-SVR-3.csv')

data_csv_0['Timestamp'] = pd.to_datetime(data_csv_0['Timestamp'], unit='s', origin=pd.Timestamp('1970-01-01 08:00:00'))
data_0 = data_csv_0[(data_csv_0['Timestamp'] >= pd.to_datetime('2020-01-29 00:01:00')) &
                    (data_csv_0['Timestamp'] <= pd.to_datetime('2020-01-29 23:10:00'))]
data_csv_1['Timestamp'] = pd.to_datetime(data_csv_1['Timestamp'], unit='s', origin=pd.Timestamp('1970-01-01 08:00:00'))
data_1 = data_csv_1[(data_csv_1['Timestamp'] >= pd.to_datetime('2020-01-29 00:01:00')) &
                    (data_csv_1['Timestamp'] <= pd.to_datetime('2020-01-29 23:10:00'))]
data_csv_2['Timestamp'] = pd.to_datetime(data_csv_2['Timestamp'], unit='s', origin=pd.Timestamp('1970-01-01 08:00:00'))
data_2 = data_csv_2[(data_csv_2['Timestamp'] >= pd.to_datetime('2020-01-29 00:01:00')) &
                    (data_csv_2['Timestamp'] <= pd.to_datetime('2020-01-29 23:10:00'))]
data_csv_3['Timestamp'] = pd.to_datetime(data_csv_3['Timestamp'], unit='s', origin=pd.Timestamp('1970-01-01 08:00:00'))
data_3 = data_csv_3[(data_csv_3['Timestamp'] >= pd.to_datetime('2020-01-29 00:01:00')) &
                    (data_csv_3['Timestamp'] <= pd.to_datetime('2020-01-29 23:10:00'))]

data_csv_4['Timestamp'] = pd.to_datetime(data_csv_4['Timestamp'], unit='s', origin=pd.Timestamp('1970-01-01 08:00:00'))
data_4 = data_csv_4[(data_csv_4['Timestamp'] >= pd.to_datetime('2020-01-29 00:01:00')) &
                    (data_csv_4['Timestamp'] <= pd.to_datetime('2020-01-29 23:10:00'))]

fig = plt.figure(figsize=(16, 8))

plt.xlabel('Time', position=(1, 1))
plt.ylabel('Predict value of dissolved oxygen (mg/L)')


def formatnum(x, pos):
    return '$%.2f$' % (x * 1000)


plt.gca().xaxis.set_major_formatter(mdates.DateFormatter("%H:%M"))
plt.xticks(fontsize=10)
plt.yticks(fontsize=10)

plt.plot(data_0['Timestamp'], data_0['real'], 'x:', label='Original dissolved oxygen data', linewidth=1,
         color='#3D6E8D')
plt.plot(data_0['Timestamp'], data_0['predict'], '.-', label='Noble Semi-naive Bayes', linewidth=1, color='#CCDA9C')
plt.plot(data_2['Timestamp'], data_2['predict'], '.-', label='Multi-layer Perceptron regressor', linewidth=1,
         color='#E58E61')
plt.plot(data_1['Timestamp'], data_1['predict'], '.-', label='RBF neural network', linewidth=1, color='#F3BE95')
plt.plot(data_3['Timestamp'], data_3['predict'], '.-', label='LSTM', linewidth=1, color='#E8D5CF')
plt.plot(data_4['Timestamp'], data_4['predict'], '.-', label='SVR', linewidth=1, color='#FDACBB')
plt.legend(loc='upper right')
plt.savefig('ComparisonChartOfDifferentAlgorithms', dpi=300, bbox_inches='tight')
