import pandas as pd
import matplotlib.pyplot as plt
from matplotlib.ticker import FuncFormatter
import matplotlib.dates as mdates


def formatnum(x, pos):
    return '$%.2f$' % (x * 1000)


if __name__ == '__main__':
    fig = plt.figure(figsize=(20, 20))
    for index in range(1, 17):
        print(index)
        plt.subplot(4, 4, index)
        data_csv_0 = pd.read_csv('./../data/bestResult/' + str(index) + '.txt')

        data_csv_0['Timestamp'] = pd.to_datetime(data_csv_0['Timestamp'], unit='s',
                                                 origin=pd.Timestamp('1970-01-01 08:00:00'))
        if index == 1 or index == 3 or index == 9 or index == 11 or index == 12:
            data_0 = data_csv_0[(data_csv_0['Timestamp'] >= pd.to_datetime('2020-01-10 00:00:00')) &
                                (data_csv_0['Timestamp'] <= pd.to_datetime('2020-01-10 23:59:59'))]
        elif index == 2 or index == 4 or index == 5 or index == 7 or index == 14:
            data_0 = data_csv_0[(data_csv_0['Timestamp'] >= pd.to_datetime('2020-03-05 00:00:00')) &
                                (data_csv_0['Timestamp'] <= pd.to_datetime('2020-03-05 23:59:59'))]
        elif index == 6 or index == 8:
            data_0 = data_csv_0[(data_csv_0['Timestamp'] >= pd.to_datetime('2020-05-11 00:00:00')) &
                                (data_csv_0['Timestamp'] <= pd.to_datetime('2020-05-11 23:59:59'))]
        elif index == 10:
            data_0 = data_csv_0[(data_csv_0['Timestamp'] >= pd.to_datetime('2020-05-11 00:00:00')) &
                                (data_csv_0['Timestamp'] <= pd.to_datetime('2020-05-11 23:59:59'))]
        elif index == 13:
            data_0 = data_csv_0[(data_csv_0['Timestamp'] >= pd.to_datetime('2019-12-25 00:00:00')) &
                                (data_csv_0['Timestamp'] <= pd.to_datetime('2019-12-25 23:59:59'))]
        elif index == 15:
            data_0 = data_csv_0[(data_csv_0['Timestamp'] >= pd.to_datetime('2020-03-31 00:00:00')) &
                                (data_csv_0['Timestamp'] <= pd.to_datetime('2020-03-31 23:59:59'))]
        elif index == 16:
            data_0 = data_csv_0[(data_csv_0['Timestamp'] >= pd.to_datetime('2020-05-17 00:00:00')) &
                                (data_csv_0['Timestamp'] <= pd.to_datetime('2020-05-17 23:59:59'))]

        plt.xlabel('Time', position=(1, 1))
        plt.ylabel('Difference of dissolved oxygen (mg/L)')
        plt.title('Ranch Number:' + str(index))

        plt.gca().xaxis.set_major_formatter(mdates.DateFormatter("%H:%M"))
        formatter = FuncFormatter(formatnum)
        plt.xticks(fontsize=10)
        plt.yticks(fontsize=10)

        plt.plot(data_0['Timestamp'], data_0['real'], 'x:', label='Origin', linewidth=1)
        plt.plot(data_0['Timestamp'], data_0['predict'], 'D--', label='NSB', linewidth=1)
        plt.legend(loc='upper right')

    plt.tight_layout()
    plt.savefig('ComparisonOfPredictedAndTrueValues.pdf', dpi=300, bbox_inches='tight')
