import pandas as pd
from diebold_mariano_test import *

if __name__ == '__main__':
    my_data = pd.read_csv('result_L_5_m_20.txt')
    data_csv_file_name = ['Result-SVR/Result-SVR-3.csv', 'Result-lstm/Result-LSTM-1-8.csv', 'Result-MLPRegressor.csv',
                          'Result-RBF.csv']
    comp_datas = [pd.read_csv(file_name) for file_name in data_csv_file_name]

    min_time = int(my_data[:1]['Timestamp'])
    for data_file in comp_datas:
        if int(data_file[:1]['Timestamp']) < min_time:
            min_time = int(data_file[:1]['Timestamp'])

    print(min_time)

    max_time = int(my_data[-1:]['Timestamp'])
    print(max_time)
    for data_file in comp_datas:
        if int(data_file[-1:]['Timestamp']) > max_time:
            max_time = int(data_file[-1:]['Timestamp'])
    print(max_time)

    my_data = my_data[(my_data['Timestamp'] >= min_time) &
                      (my_data['Timestamp'] <= max_time)]

    comp_datas = [comp_data[(comp_data['Timestamp'] >= min_time) &
                            (comp_data['Timestamp'] <= max_time)] for comp_data in comp_datas]

    for comp_data in comp_datas:
        comp_data['diff'] = comp_data['real'] - comp_data['predict']

    my_data['diff'] = my_data['real'] - my_data['predict']

    for i in range(len(data_csv_file_name)):
        my_data_set = []
        other_data_set = []
        original_data_set = []
        for ori in my_data['Timestamp']:
            if comp_datas[i][comp_datas[i]['Timestamp'] == int(ori)].empty:
                continue
            else:
                my_data_set.append(float(my_data[my_data['Timestamp'] == ori]['predict']))
                other_data_set.append(float(comp_datas[i][comp_datas[i]['Timestamp'] == int(ori)]['predict']))
                original_data_set.append(float(my_data[my_data['Timestamp'] == ori]['real']))
        d_t_list = cul_d_t(MAE, original_data_set, my_data_set, other_data_set)
        print(data_csv_file_name[i])
        print("DM: " + str(cul_DM(d_t_list)))
        print("P: " + str(cul_P(d_t_list)))
        print("##########")
